<!DOCTYPE html>
<html>
  <head>
    <meta content="text/html; charset=iso-8859-1" http-equiv="content-type">
    <title>Internal engine</title>
    <link title="sa-styles" href="../css/sa.css" rel="stylesheet" type="text/css">
  </head>
  <body>
    <div id="banner"> <img src="../images/help_banner.jpg" alt="Help banner"> </div>
    <div id="content">
      <h1>Internal engine</h1>
      <h2>Results access</h2>
      <p>To access to the propagation results generated by the internal engine : </p>
      <ol>
        <li>In the <em>Project Explorer</em> view, open the folder <em>propagation / InternalEngine</em></li>
        <li>Select the right folder corresponding to the wanted analysis. The folder name contains the analysis date and
          time, to be able to find it easily</li>
        <li>Select the result file corresponding to the wanted feared event</li>
        <img class="bordered" alt="img" src="images/analyseGlobale/resultats_internal.jpg">
        <li>Open the file to display the generated fault tree :&nbsp; </li>
        <img alt="img" src="images/analyseGlobale/resultats_fichier_internal.jpg" class="bordered">
        <li>To expand only one node, click on the <img class="icon" title="AnalyseGlobale_6.jpg" alt="" src="images/analyseGlobale/AnalyseGlobale_6.jpg">
          on the left of each node.</li>
        <li>To expand or collapse the whole tree, click on the corresponding button in the editor tool bar&nbsp; :</li>
        <img alt="img" src="images/analyseGlobale/boutons_propagation_resultats.jpg" class="bordered"><br>
      </ol>
      <h2>Propagation rules</h2>
      <p>The global analysis use some rules to define how the failures are propagated between the components, according
        to the failure modes used. Thus, these rules define if a failure is propagated from a failure mode to an other,
        following the data links between the components ports. Here are the existing rules :</p>
      <table>
        <tbody>
          <tr>
            <th width="250">Source failure mode&nbsp; \ Target failure mode<br>
            </th>
            <th width="75">Absent</th>
            <th width="75">Untimely</th>
            <th width="75">Erroneous</th>
            <th width="75">Specific erroneous</th>
            <th width="75">No effect</th>
          </tr>
          <tr>
            <th>Absent</th>
            <td class="centered">X</td>
            <td><br>
            </td>
            <td><br>
            </td>
            <td><br>
            </td>
            <td><br>
            </td>
          </tr>
          <tr>
            <th>Untimely</th>
            <td><br>
            </td>
            <td class="centered">X</td>
            <td><br>
            </td>
            <td><br>
            </td>
            <td><br>
            </td>
          </tr>
          <tr>
            <th>Erroneous</th>
            <td><br>
            </td>
            <td><br>
            </td>
            <td class="centered">X</td>
            <td class="centered">X</td>
            <td><br>
            </td>
          </tr>
          <tr>
            <th>Specific erroneous</th>
            <td><br>
            </td>
            <td><br>
            </td>
            <td><br>
            </td>
            <td class="centered">X</td>
            <td><br>
            </td>
          </tr>
          <tr>
            <th>No effect</th>
            <td><br>
            </td>
            <td><br>
            </td>
            <td><br>
            </td>
            <td><br>
            </td>
            <td><br>
            </td>
          </tr>
        </tbody>
      </table>
      <p>For example : </p>
      <ul>
        <li>Let a component X with an output OUT associated to two failure modes : <em>Absent</em> and <em>Specific
            Erroneous</em></li>
        <li>Let a composant Y with an input IN associated to two failure modes <em>Erroneous </em>and&nbsp;<em>Absent</em></li>
        <li>Let a data link with OUT as source, and IN as target</li>
        <li>The only failure propagations will be OUT(Absent) -&gt; IN(Absent). <br>
          There won't be a failure propagation between OUT(Specific Erroneous) -&gt; IN(Erroneous)</li>
      </ul>
      <h2>Specific behaviour</h2>
      <h3>Loop management</h3>
      <p>During the propagation, some loops can be found. A loop is detected when on a branch the same failure item is
        found twice. </p>
      <p>There is two kinds of loop : </p>
      <ul>
        <li>internal loop</li>
        <ul>
          <li>An internal loop can appear if a mistake has been done in the block local analysis.</li>
        </ul>
        <li>data loop</li>
        <ul>
          <li>A data loop appears when the input of a block is linked (directly or indirectly) to its output. It is a
            common case, and not necessary an error.</li>
        </ul>
      </ul>
      <p>When a loop is detected, the propagation is stopped on the current branch. This information is shown in
        propagation tree by a loop icon : <img class="icon" title="icon_loop.jpg" alt="" src="images/analyseGlobale/icon_loop.jpg"></p>
      <h3>Internal engine preferences</h3>
      <p>To open the internal engine preferences page, click on <span style="font-style: italic;">Window &gt; Preferences
          &gt; Global Analysis &gt; Propagation &gt; Internal Engine</span></p>
      <h4>Propagation limit</h4>
      <p>This option is the maximum of node elements kept by the propagation. If this limitation is reached before the
        propagation ended, the propagation will be stopped.</p>
      <p>Be careful : This value has a direct impact on memory print of Eclipse Safety Framework and on your propagation
        results.</p>
      <ul>
      </ul>
      <h2>Feared events association inheritance</h2>
      <h3>Behaviour</h3>
      <p>When the global analysis is performed with the internal engine on a feared events family, the failure modes
        associated to this family will inherit of all the feared events linked to this family.&nbsp;</p>
      <h3>Example</h3>
      <p>Let the following library :</p>
      <img title="propagation_example_library" alt="" src="images/analyseGlobale/exempleInternal/propagation_example_library.jpg"
        class="bordered"><br>
      If the feared events and feared events families associations is the following :<br>
      <img title="propagation_example_association" alt="" src="images/analyseGlobale/exempleInternal/propagation_example_association.jpg"
        class="bordered"><br>
      Then the propagation result performed on the F1 family will be : <br>
      <img title="propagation_example_result" alt="" src="images/analyseGlobale/exempleInternal/propagation_example_result.jpg"
        class="bordered"><br>
      Indeed, the inheritance has been applied like this :<br>
      <ul>
        <li>FE2 inherits of the associations owned by F1 and F2, respectively US1 and US2</li>
        <li>FE1 inherits of the associations owned by F1, that is US1</li>
        <li>FE2 doesn't inherit of the association owned by F3 in this propagation, as F3 is not referenced by F1</li>
      </ul>
      <ul>
        <ul>
        </ul>
      </ul>
      <br>
    </div>
  </body>
</html>
